// Motion_test.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "Motion_test.h"
#include "ValExt.h"
#include "WinConSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


int Star_A;
bool Auto_Get;
WORD m_nTimer;


/////////////////////////////////////////////////////////////////////////////
// Motion_test dialog


Motion_test::Motion_test(CWnd* pParent /*=NULL*/)
	: CDialog(Motion_test::IDD, pParent)
{
	//{{AFX_DATA_INIT(Motion_test)
	m_UAcc = 0;
	m_UE = 0;
	m_UP = 0;
	m_USpeed = 0;
	m_XAcc = 0;
	m_XE = 0;
	m_XP = 0;
	m_XSpeed = 0;
	m_YAcc = 0;
	m_YE = 0;
	m_YP = 0;
	m_ZAcc = 0;
	m_YSpeed = 0;
	m_ZE = 0;
	m_ZP = 0;
	m_ZSpeed = 0;
	m_Msg = _T("");
	//}}AFX_DATA_INIT
}


void Motion_test::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Motion_test)
	DDX_Control(pDX, IDC_Auto, m_CAuto);
	DDX_Text(pDX, IDC_UAcc, m_UAcc);
	DDX_Text(pDX, IDC_UE, m_UE);
	DDX_Text(pDX, IDC_UP, m_UP);
	DDX_Text(pDX, IDC_USpeed, m_USpeed);
	DDX_Text(pDX, IDC_XAcc, m_XAcc);
	DDX_Text(pDX, IDC_XE, m_XE);
	DDX_Text(pDX, IDC_XP, m_XP);
	DDX_Text(pDX, IDC_XSpeed, m_XSpeed);
	DDX_Text(pDX, IDC_YAcc, m_YAcc);
	DDX_Text(pDX, IDC_YE, m_YE);
	DDX_Text(pDX, IDC_YP, m_YP);
	DDX_Text(pDX, IDC_ZAcc, m_ZAcc);
	DDX_Text(pDX, IDC_YSpeed, m_YSpeed);
	DDX_Text(pDX, IDC_ZE, m_ZE);
	DDX_Text(pDX, IDC_ZP, m_ZP);
	DDX_Text(pDX, IDC_ZSpeed, m_ZSpeed);
	DDX_Text(pDX, IDC_Msg, m_Msg);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Motion_test, CDialog)
	//{{AFX_MSG_MAP(Motion_test)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_Auto, OnAuto)
	ON_BN_CLICKED(IDC_Manual_Get, OnManualGet)
	ON_BN_CLICKED(IDC_Servo_On_All, OnServoOnAll)
	ON_BN_CLICKED(IDC_Servo_Off_All, OnServoOffAll)
	ON_BN_CLICKED(IDC_HOME_SETX, OnHomeSetx)
	ON_BN_CLICKED(IDC_HOME_SETY, OnHomeSety)
	ON_BN_CLICKED(IDC_HOME_SETZ, OnHomeSetz)
	ON_BN_CLICKED(IDC_HOME_SETU, OnHomeSetu)
	ON_BN_CLICKED(IDC_Axis1_1, OnAxis11)
	ON_BN_CLICKED(IDC_Axis1_2, OnAxis12)
	ON_BN_CLICKED(IDC_Axis1_0, OnAxis1_0)
	ON_BN_CLICKED(IDC_Axis1_3, OnAxis1_3)
	ON_BN_CLICKED(IDC_Axis1_4, OnAxis1_4)
	ON_BN_CLICKED(IDC_Stop_A, OnStopA)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_Clear_Error, OnClearError)
	ON_BN_CLICKED(IDC_Axis2_0, OnAxis2_0)
	ON_BN_CLICKED(IDC_Axis2_1, OnAxis2_1)
	ON_BN_CLICKED(IDC_Axis2_2, OnAxis2_2)
	ON_BN_CLICKED(IDC_Axis2_3, OnAxis2_3)
	ON_BN_CLICKED(IDC_Axis2_4, OnAxis2_4)
	ON_BN_CLICKED(IDC_Axis2_5, OnAxis2_5)
	ON_BN_CLICKED(IDC_Axis2_6, OnAxis2_6)
	ON_BN_CLICKED(IDC_RECTAN, OnRectan)
	ON_BN_CLICKED(IDC_GEAR, OnGear)
	ON_BN_CLICKED(IDC_Helix_A, OnHelixA)
	ON_BN_CLICKED(IDC_Helix_B, OnHelixB)
	ON_BN_CLICKED(IDC_C_Move, OnCMove)
	ON_BN_CLICKED(IDC_Get_Error, OnGetError)
	ON_BN_CLICKED(IDC_Axis3_7, OnAxis3_7)
	ON_BN_CLICKED(IDC_Axis3_8, OnAxis3_8)
	ON_BN_CLICKED(IDC_Axis3_9, OnAxis3_9)
	ON_BN_CLICKED(IDC_Axis3_10, OnAxis3_10)
	ON_BN_CLICKED(IDC_Axis3_11, OnAxis3_11)
	ON_BN_CLICKED(IDC_BT_SYNC1, OnBtSync1)
	ON_BN_CLICKED(IDC_BT_SYNC2, OnBtSync2)
	ON_BN_CLICKED(IDC_BT_DRV_HS, OnBtDrvHs)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL Motion_test::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	Auto_Get=false;
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void Motion_test::Show_Msg(int AA)
{
	m_Msg.Format(_T("%d"),AA);
	UpdateData(FALSE);
}

void Motion_test::Show_Msg(CString AA)
{
	m_Msg=AA;
	UpdateData(FALSE);
}

/////////////////////////////////////////////////////////////////////////////
// Motion_test message handlers

void Motion_test::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent==1)
	{
		m_XP=i8094MF_GET_LP(cardNo, AXIS_X);
		m_XSpeed=i8094MF_GET_CV(cardNo, AXIS_X);
		m_XAcc=i8094MF_GET_CA(cardNo, AXIS_X);
		m_XE=i8094MF_GET_EP(cardNo, AXIS_X);
		
		m_YP=i8094MF_GET_LP(cardNo, AXIS_Y);
		m_YSpeed=i8094MF_GET_CV(cardNo, AXIS_Y);
		m_YAcc=i8094MF_GET_CA(cardNo, AXIS_Y);
		m_YE=i8094MF_GET_EP(cardNo, AXIS_Y);
		
		m_ZP=i8094MF_GET_LP(cardNo, AXIS_Z);
		m_ZSpeed=i8094MF_GET_CV(cardNo, AXIS_Z);
		m_ZAcc=i8094MF_GET_CA(cardNo, AXIS_Z);
		m_ZE=i8094MF_GET_EP(cardNo, AXIS_Z);
		
		m_UP=i8094MF_GET_LP(cardNo, AXIS_U);
		m_USpeed=i8094MF_GET_CV(cardNo, AXIS_U);
		m_UAcc=i8094MF_GET_CA(cardNo, AXIS_U);
		m_UE=i8094MF_GET_EP(cardNo, AXIS_U);
		//OnManualGet();
		UpdateData(false);
    }
	
	
	CDialog::OnTimer(nIDEvent);
}

void Motion_test::OnAuto() 
{
	// TODO: Add your control notification handler code here
	Auto_Get= ! Auto_Get;
	if (Auto_Get)
    {
		SetTimer(1, 5, 0);
		m_CAuto.SetWindowText(_T("Auto Update Off"));
	}
	else
	{
		KillTimer(1);  
		//KillTimer(2);
		m_CAuto.SetWindowText(_T("Auto Update On"));
	}
}

void Motion_test::OnManualGet() 
{
	// TODO: Add your control notification handler code here
	DWORD Start_T,Stop_T;
    Start_T=GetTickCount();
	m_XP=i8094MF_GET_LP(cardNo, AXIS_X);
	m_XSpeed=i8094MF_GET_CV(cardNo, AXIS_X);
	m_XAcc=i8094MF_GET_CA(cardNo, AXIS_X);
	m_XE=i8094MF_GET_EP(cardNo, AXIS_X);
	
	m_YP=i8094MF_GET_LP(cardNo, AXIS_Y);
	m_YSpeed=i8094MF_GET_CV(cardNo, AXIS_Y);
	m_YAcc=i8094MF_GET_CA(cardNo, AXIS_Y);
	m_YE=i8094MF_GET_EP(cardNo, AXIS_Y);
	
	m_ZP=i8094MF_GET_LP(cardNo, AXIS_Z);
	m_ZSpeed=i8094MF_GET_CV(cardNo, AXIS_Z);
	m_ZAcc=i8094MF_GET_CA(cardNo, AXIS_Z);
	m_ZE=i8094MF_GET_EP(cardNo, AXIS_Z);
	
	m_UP=i8094MF_GET_LP(cardNo, AXIS_U);
	m_USpeed=i8094MF_GET_CV(cardNo, AXIS_U);
	m_UAcc=i8094MF_GET_CA(cardNo, AXIS_U);
	m_UE=i8094MF_GET_EP(cardNo, AXIS_U);
	
	UpdateData(false);
	Stop_T=GetTickCount();
	Show_Msg(Stop_T-Start_T);
	UpdateData(false);
}

void Motion_test::OnServoOnAll() 
{
	// TODO: Add your control notification handler code here
	i8094MF_SERVO_ON(cardNo, 0xf);
}

void Motion_test::OnServoOffAll() 
{
	// TODO: Add your control notification handler code here
	i8094MF_SERVO_OFF(cardNo, 0xf);
}

void Motion_test::OnHomeSetx() 
{
	// TODO: Add your control notification handler code here
	BYTE m_Axis=AXIS_X;
	i8094MF_SET_MAX_V(cardNo, m_Axis, 32000); 
	i8094MF_NORMAL_SPEED(cardNo, m_Axis, 0);		//set axis as Symmetrical T curve mode
	i8094MF_SET_V(cardNo, m_Axis, 20000);			//set v=20000 PPS
	i8094MF_SET_A(cardNo, m_Axis, 100000);			//set acc=100000 PPS/S     
	i8094MF_SET_HV(cardNo, m_Axis, 20000);	
	i8094MF_SET_HOME_MODE(cardNo, m_Axis, 0, 2, 1, 1, 10000);
	i8094MF_HOME_START(cardNo, m_Axis);
	Sleep(100);
	while (i8094MF_HOME_WAIT(cardNo, m_Axis) == NO)
	{
		DoEvents();
		Sleep(1);
	}
	Sleep(500);
	i8094MF_SET_LP(cardNo,m_Axis,0);
	i8094MF_SET_EP(cardNo,m_Axis,0);
}

void Motion_test::OnHomeSety() 
{
	// TODO: Add your control notification handler code here
	BYTE m_Axis=AXIS_Y;
	i8094MF_SET_MAX_V(cardNo, m_Axis, 150000); 
	i8094MF_NORMAL_SPEED(cardNo, m_Axis, 0);		//set axis as Symmetrical T curve mode
	i8094MF_SET_V(cardNo, m_Axis, 50000);			//set v=50000 PPS
	i8094MF_SET_A(cardNo, m_Axis, 100000);			//set acc=100000 PPS/S  
	i8094MF_SET_HV(cardNo, m_Axis, 5000);	
	i8094MF_SET_HOME_MODE(cardNo, m_Axis, 2, 2, 1, 1, 120000);
	i8094MF_HOME_START(cardNo, m_Axis);
	Sleep(100);
	while (i8094MF_HOME_WAIT(cardNo, m_Axis) == NO)
	{
		DoEvents();
		Sleep(1);
	}
	Sleep(500);
	i8094MF_SET_LP(cardNo,m_Axis,0);
	i8094MF_SET_EP(cardNo,m_Axis,0);
}

void Motion_test::OnHomeSetz() 
{
	// TODO: Add your control notification handler code here
	BYTE m_Axis=AXIS_Z;
	i8094MF_SET_MAX_V(cardNo, m_Axis, 32000); 
	i8094MF_NORMAL_SPEED(cardNo, m_Axis, 0);		//set axis as Symmetrical T curve mode
	i8094MF_SET_V(cardNo, m_Axis, 30000);			//set v=30000 PPS
	i8094MF_SET_A(cardNo, m_Axis, 100000);			//set acc=100000 PPS/S  
	i8094MF_SET_HV(cardNo, m_Axis, 20000);	
	i8094MF_SET_HOME_MODE(cardNo, m_Axis, 0, 2, 1, 1, 10000);
	i8094MF_HOME_START(cardNo, m_Axis);
	Sleep(100);
	while (i8094MF_HOME_WAIT(cardNo, m_Axis) == NO)
	{
		DoEvents();
		Sleep(1);
	}
	Sleep(800);
	i8094MF_SET_LP(cardNo,m_Axis,0);
	i8094MF_SET_EP(cardNo,m_Axis,0);
}

void Motion_test::OnHomeSetu() 
{
	// TODO: Add your control notification handler code here
	BYTE m_Axis=AXIS_U;
	i8094MF_SET_MAX_V(cardNo, m_Axis, 32000); 
	i8094MF_NORMAL_SPEED(cardNo, m_Axis, 0);		//set axis as Symmetrical T curve mode
	i8094MF_SET_V(cardNo, m_Axis, 2000);			//set v=2000 PPS
	i8094MF_SET_A(cardNo, m_Axis, 100000);			//set acc=100000 PPS/S  
	i8094MF_SET_HV(cardNo, m_Axis, 500);	
	i8094MF_SET_HOME_MODE(cardNo, m_Axis, 0, 2, 1, 1, 200);
	i8094MF_HOME_START(cardNo, m_Axis);
	Sleep(100);
	while (i8094MF_HOME_WAIT(cardNo, m_Axis) == NO)
	{
		DoEvents();
		Sleep(1);
	}
	Sleep(500);
	i8094MF_SET_LP(cardNo,m_Axis,0);
	i8094MF_SET_EP(cardNo,m_Axis,0);
}

void Motion_test::OnAxis1_0() 
{
	// TODO: Add your control notification handler code here
	BYTE axis=AXIS_X;  //for AXIS_X it can be to AXIS_XYZU
	i8094MF_SET_MAX_V(cardNo, axis, 20000); 
	i8094MF_NORMAL_SPEED(cardNo, axis, 0);		//set axis as Symmetrical T curve mode
	i8094MF_SET_V(cardNo, axis, 20000);			//set v=20000 PPS
	i8094MF_SET_A(cardNo, axis, 100000);		//set acc=100000 PPS/S
	i8094MF_SET_SV(cardNo, axis, 10);			//set start speed=1000 PPS
	i8094MF_SET_AO(cardNo, axis, 0);			//set offset pulse (at SV speed)= 0 PS
    i8094MF_FIXED_MOVE(cardNo, axis, 10000);	//run the fixed 10000 Pulse move.
	while (i8094MF_STOP_WAIT(cardNo, axis) == NO)
	{
		DoEvents();
		Sleep(1);
		//wait for axis to stop
	}
	i8094MF_FIXED_MOVE(cardNo, axis, -10000);	//run the fixed -10000 Pulse move.	
}


void Motion_test::OnAxis11() 
{
	// TODO: Add your control notification handler code here
    BYTE axis=AXIS_X; //for AXIS_X it can be to AXIS_XYZU
	i8094MF_SET_MAX_V(cardNo, axis, 20000); 
    i8094MF_NORMAL_SPEED(cardNo, axis, 1);		//set axis as Symmetrical S curve mode
	i8094MF_SET_V(cardNo, axis, 20000);			//set v=20000 PPS 
	i8094MF_SET_K(cardNo, axis, 50000);			//set K=500000 PPS/s^2
	i8094MF_SET_SV(cardNo, axis, 200);			//set start speed SV=200 PPS
	i8094MF_SET_AO(cardNo, axis, 9);			//set offset pulse(at SV speed)= 9 PS
    i8094MF_FIXED_MOVE(cardNo, axis, -10000);	//run the fixed -10000 Pulse move.
}

void Motion_test::OnAxis12() 
{
	// TODO: Add your control notification handler code here
	BYTE axis=AXIS_X; //for AXIS_X it can be to AXIS_XYZU
	i8094MF_SET_MAX_V(cardNo, axis, 20000); 
	i8094MF_NORMAL_SPEED(cardNo, axis, 2);		//set axis as Non-Symmetrical T curve mode
	i8094MF_SET_V(cardNo, axis, 20000);			//set v=20000 PPS
	i8094MF_SET_A(cardNo, axis, 100000);		//set acc A=100000 PPS/s
	i8094MF_SET_D(cardNo, axis, 100000);			//set dec D=100000 PPS/s
	i8094MF_SET_SV(cardNo, axis, 200);			//set start speed SV=200 PPS
	i8094MF_SET_AO(cardNo, axis, 9);			//set offset pulse(at SV speed)= 9 PS
    i8094MF_FIXED_MOVE(cardNo, axis, 10000);	//run the fixed 10000 Pulse move.
}


void Motion_test::OnAxis1_3() 
{
	// TODO: Add your control notification handler code here
	BYTE axis=AXIS_X; //for AXIS_X it can be to AXIS_XYZU
	i8094MF_SET_MAX_V(cardNo, axis, 20000); 
    i8094MF_NORMAL_SPEED(cardNo, axis, 3);		//set axis as Non-Symmetrical S curve mode
	i8094MF_SET_V(cardNo, axis, 20000);			//set speed V=20000 PPS
	i8094MF_SET_K(cardNo, axis, 50000);			//set K=500000 PPS/s^2
	i8094MF_SET_L(cardNo, axis, 5000);			//set L=50000 PPS/s^2
	i8094MF_SET_SV(cardNo, axis, 200);			//set start speed SV=200 PPS
	i8094MF_SET_AO(cardNo, axis, 9);			//set offset pulse(at SV speed)= 9 PS
    i8094MF_FIXED_MOVE(cardNo, axis, 20000);	//run the fixed 20000 Pulse move.
		
}

void Motion_test::OnAxis1_4() 
{
	// TODO: Add your control notification handler code here
	i8094MF_CONTINUE_MOVE(cardNo, AXIS_X, 10000);
	//let AXIS X CONTINUE MOVE at 10000 pps speed
}

void Motion_test::OnStopA() 
{
	// TODO: Add your control notification handler code here
	i8094MF_STOP_SLOWLY(cardNo,AXIS_XYZU);
	//the ERROR will active please call the i8094MF_CLEAR_ERROR function to clear
}

void Motion_test::OnStop() 
{
	// TODO: Add your control notification handler code here
	i8094MF_STOP_SUDDENLY(cardNo,AXIS_XYZU);
	//the ERROR will active please call the i8094MF_CLEAR_ERROR function to clear
	
}

void Motion_test::OnClearError() 
{
	// TODO: Add your control notification handler code here
	//i8094MF_CLEAR_ERROR(cardNo);
	i8094MF_CLEAR_STOP(cardNo);
}

void Motion_test::OnAxis2_0() 
{
	// TODO: Add your control notification handler code here
	BYTE axis=AXIS_XY;  //for AXIS_XY it can be to AXIS_XYZU
	i8094MF_SET_MAX_V(cardNo, axis, 20000); 
	i8094MF_AXIS_ASSIGN(cardNo, AXIS_X, AXIS_Y, 0);	
	//set the axis1 as X axis2 as Y for interpolation axisC
	i8094MF_VECTOR_SPEED(cardNo, 0);					
	//set for cons speed Interpolation (VSV=VV)
	i8094MF_SET_VV(cardNo, 20000);			//set the vector speed as 20000 PPS.
	i8094MF_LINE_2D(cardNo, 12000, 10000);	//run the 2 axis interpolation.
}

void Motion_test::OnAxis2_1() 
{
	// TODO: Add your control notification handler code here
	BYTE axis=AXIS_XY;  //for AXIS_XY it can be to AXIS_XYZU
	i8094MF_SET_MAX_V(cardNo, axis, 20000); 
	i8094MF_AXIS_ASSIGN(cardNo, AXIS_X, AXIS_Y, 0); 
	//set the axis1 as X axis2 as Y for interpolation axis.
	i8094MF_VECTOR_SPEED(cardNo, 1);      
	//set 2 axis as Symmetrical T curve mode (VSVBVVBVABVAO)
	i8094MF_SET_VSV(cardNo, 500);			//set the vector start speed as 500 PPS.
	i8094MF_SET_VV(cardNo, 20000);			//set the vector speed as 20000 PPS.
	i8094MF_SET_VA(cardNo, 10000);			//set the vector acc. 10000 PPS/s.
	i8094MF_SET_VAO(cardNo, 20);			//set the vector offset pulse(at VSV speed)= 20 PS
	i8094MF_LINE_2D(cardNo, 10000, 8000);	//the 2 axis interpolation.
}

void Motion_test::OnAxis2_2() 
{
	// TODO: Add your control notification handler code here
	BYTE axis=AXIS_XY;  //for AXIS_XY it can be to AXIS_XYZU
	i8094MF_SET_MAX_V(cardNo, axis, 30000); 
	i8094MF_AXIS_ASSIGN(cardNo, AXIS_X, AXIS_Y, 0); 
	//set the axis1 as X axis2 as Y for interpolation axis.
	i8094MF_VECTOR_SPEED(cardNo, 2);      
	//set 2 axis as Symmetrical S curve mode (VSVBVVBVABVKBVAO)
	i8094MF_SET_VSV(cardNo, 2000);			//set the vector start speed as 2000 PPS.
	i8094MF_SET_VV(cardNo, 20000);			//set the vector speed as 20000 PPS.
	i8094MF_SET_VK(cardNo, 5000);			//set K=50000 PPS/s^2 
	i8094MF_SET_VAO(cardNo, 20);			//set the vector offset pulse(at VSV speed)= 20 PS
	i8094MF_LINE_2D(cardNo, 10000, 10000);	//the 2 axis interpolation.
}

void Motion_test::OnAxis2_3() 
{
	// TODO: Add your control notification handler code here
	BYTE axis=AXIS_XY;  //for AXIS_XY it can be to AXIS_XYZU
	i8094MF_SET_MAX_V(cardNo, axis, 20000); 
	i8094MF_AXIS_ASSIGN(cardNo, AXIS_X, AXIS_Y, 0); 
	//set the axis1 as X axis2 as Y for interpolation axis.
	i8094MF_VECTOR_SPEED(cardNo, 3);      
	//set 2 axis as Non-Symmetrical T curve mode (VSVBVVBVABVDBVAO)
	i8094MF_SET_VSV(cardNo, 100);			//set the vector start speed as 100 PPS.
	i8094MF_SET_VV(cardNo, 20000);			//set the vector speed as 20000 PPS.
	i8094MF_SET_VA(cardNo, 100000);			//set the vector acc as 100000 PPS/s.
	i8094MF_SET_VD(cardNo, 50000);			//set the vector dec as 50000 PPS/s.
	i8094MF_SET_VAO(cardNo, 20);			//set the vector offset pulse(at VSV speed)= 20 PS
	i8094MF_LINE_2D(cardNo, 10000, 5000);	//the 2 axis interpolation.
}

void Motion_test::OnAxis2_4() 
{
	// TODO: Add your control notification handler code here
	long fp1=20000;
	long fp2=-20000;
	int sv=100;
	int v=20000;  
	BYTE axis=AXIS_XY;  //for AXIS_XY it can be to AXIS_XYZU
	i8094MF_SET_MAX_V(cardNo, axis, 30000); 
	i8094MF_AXIS_ASSIGN(cardNo, AXIS_X, AXIS_Y, 0); 
	//set the axis1 as X axis2 as Y for interpolation axis.
	i8094MF_VECTOR_SPEED(cardNo, 4);		
	//set 2 axis as Non-Symmetrical S curve mode  (VSVBVVBVABVDBVKBVLBVAO)
	i8094MF_SET_VSV(cardNo, sv);			//set the vector start speed as sv PPS.
	i8094MF_SET_VV(cardNo, v);				//set the vector speed as v PPS. 
	i8094MF_SET_VK(cardNo, 50000);			//set K=500000 PPS/s^2
	i8094MF_SET_VL(cardNo, 5000);			//set L=50000 PPS/s^2
	i8094MF_SET_VAO(cardNo, 20);			//set the vector offset pulse(at VSV speed)= 20 PS
	i8094MF_LINE_2D(cardNo, fp1, fp2);		//the 2 axis interpolation.
}

void Motion_test::OnAxis2_5() 
{
	// TODO: Add your control notification handler code here
	long fp1=20000;
	long fp2=20000;
	long c1=20000;
	long c2=0;
	int sv=100;
	int v=30000;
	int a=50000; 
	i8094MF_SET_MAX_V(cardNo, AXIS_XYZU,80000);
	i8094MF_AXIS_ASSIGN(cardNo, AXIS_X, AXIS_Y, 0); 
	//set the axis1 as X axis2 as Y for interpolation axis.
	i8094MF_VECTOR_SPEED(cardNo, 5);		
	//set 2 axis as circular symmetrical T curve mode (VSVBVVBVABVAO)
	i8094MF_SET_VSV(cardNo, sv);				//set the vector start speed as sv PPS.
	i8094MF_SET_VV(cardNo, v);					//set the vector speed as v PPS.
	i8094MF_SET_VA(cardNo, a);					//set the vector acc as a PPS/s. 
	i8094MF_SET_VAO(cardNo, 0);					//set the vector offset pulse(at VSV speed)= 0 PS
	i8094MF_ARC_CW(cardNo, c1,c2, fp1, fp2);	//the 2 axis ARC_CW interpolation.
}

void Motion_test::OnAxis2_6() 
{
	// TODO: Add your control notification handler code here
	long c1=5000;
	long c2=0;
	int sv=100;
	int v=30000;
	int a=50000000;
	int d=50000;
	i8094MF_SET_MAX_V(cardNo,AXIS_XYZU,80000);
	i8094MF_AXIS_ASSIGN(cardNo, AXIS_X, AXIS_Y, 0); 
	//set the axis1 as X axis2 as Y for interpolation axis.
	i8094MF_VECTOR_SPEED(cardNo, 6);		
	//set 2 axis as circular symmetrical T curve mode (VSVBVVBVABVAO)
	i8094MF_SET_VSV(cardNo, sv);		//set the vector start speed as sv PPS.
	i8094MF_SET_VV(cardNo, v);			//set the vector speed as v PPS.
	i8094MF_SET_VA(cardNo, a);			//set the vector acc as a PPS/s.
	i8094MF_SET_VD(cardNo, d);			//set the vector dec as d PPS/s.
	i8094MF_SET_VAO(cardNo, 0);			//set the vector offset pulse(at VSV speed)= 0 PS
	i8094MF_CIRCLE_CW(cardNo, c1, c2);  //the 2 axis CIRCLE_CW interpolation.
}

void Motion_test::OnRectan() 
{
	// TODO: Add your control notification handler code here
	int sv=1000;		//set the vector start speed as sv=1000 PPS.
	int v=30000;		//set the vector speed as v=30000 PPS.
	int a=15000;		//set the vector acc as a=15000 PPS/s.
	int d=15000;		//set the vector dec as d=15000 PPS/s.
	i8094MF_SET_MAX_V(cardNo, 0Xf,160000); //set max speed for all axis= 160000 PPSC
	i8094MF_RECTANGLE(cardNo, AXIS_X, AXIS_Y, 1, 0, 0, 20000, 10000, 1000, sv, v, a, d);
}

void Motion_test::OnGear() 
{
	// TODO: Add your control notification handler code here
	int sv=300;		//PPSC
	int v=15000;	//PPSC
	int a=500000;	//PPS/sC 
	int loop1;
	int loop2;
	float ratio=0.72f;
	i8094MF_SET_MAX_V(cardNo, AXIS_XYZU,160000L);
	i8094MF_RATIO_INITIAL(cardNo,AXIS_U, AXIS_X, sv, v, a, ratio); 
	for (loop2 = 0; loop2 < 5; loop2++)
	{
		for (loop1 = 0; loop1 < 5; loop1++)
		{
			i8094MF_RATIO_2D(cardNo, 0, 3600, 0);
			i8094MF_RATIO_2D(cardNo, 0, 3600, 1);
		}
		i8094MF_RATIO_2D(cardNo, 0, 7200, 0);
		i8094MF_RATIO_2D(cardNo, 0, 3600, 1);
	}
	i8094MF_RATIO_2D(cardNo, 1, 7200, 1); 
}

void Motion_test::OnHelixA() 
{
	// TODO: Add your control notification handler code here
	i8094MF_SET_MAX_V(cardNo, AXIS_XYZU,160000);
	//set max speed for all axis= 160000 PPS.
	int v=50000;	//set the vector speed as v=50000 PPS.
	i8094MF_HELIX_3D(cardNo, AXIS_Y, AXIS_Z, AXIS_X, 1, v, 0, 1000, 5, -2000); 
}

void Motion_test::OnHelixB() 
{
	// TODO: Add your control notification handler code here
	i8094MF_SET_MAX_V(cardNo, AXIS_XYZU,160000);
	int v=100000;	//set the vector speed as v=100000 PPS.
	i8094MF_HELIX_3D(cardNo, AXIS_Y, AXIS_Z, AXIS_U, 1, v, 0, 25000, 10, 3600); 
}

void Motion_test::OnCMove() 
{
	// TODO: Add your control notification handler code here
	int sv=100;			//set the vector start speed as sv=100 PPS.
	int v=50000;		//set the vector speed as v=50000 PPS.
	int a=100000;		//set the vector acc as a=100000 PPS/s.
	int d=100000;		//set the vector dec as a=100000 PPS/s.
	i8094MF_SET_MAX_V(cardNo, AXIS_XYZU,80000);
	//set max speed for all axis= 80000 PPS.
	BYTE nType[10]=	{     1,     2,     1,     2,     1,7,0,0,0,0};
	long cp1[10]=   {     0, 10000,     0,     0,     0,0,0,0,0,0};
	long cp2[10]=   {     0,     0,     0,-10000,     0,0,0,0,0,0};
	long fp1[10]=   { 10000, 10000,  1000, 10000,-31000,0,0,0,0,0};
	long fp2[10]=   { 10000, 10000,     0,-10000,-10000,0,0,0,0,0};
	long fp3[10]=   {     0,     0,     0,     0,     0,0,0,0,0,0};
    i8094MF_CONTINUE_INTP(cardNo,AXIS_X, AXIS_Y, 0, 1, sv, v, a, d, nType,cp1, cp2, fp1, fp2,fp3);
}


void Motion_test::OnGetError() 
{
	// TODO: Add your control notification handler code here
	WORD KK=0;
	KK=i8094MF_GET_ERROR(cardNo);
	CString MSGG;
	if (KK == YES)
	{
		char buffer[20];
		KK=i8094MF_GET_ERROR_CODE(cardNo, AXIS_X);
		_itoa( KK, buffer, 10 );
		MSGG="Xerr:" + CString(buffer) + "  ";
		KK=i8094MF_GET_ERROR_CODE(cardNo, AXIS_Y);
		_itoa( KK, buffer, 10 );
		MSGG=MSGG + "Yerr:" + CString(buffer) + "  ";
		KK=i8094MF_GET_ERROR_CODE(cardNo, AXIS_Z);
		_itoa( KK, buffer, 10 );
		MSGG=MSGG + "Zerr:" + CString(buffer) + "  ";
		KK=i8094MF_GET_ERROR_CODE(cardNo, AXIS_U);
		_itoa( KK, buffer, 10 );
		MSGG=MSGG + "Uerr:" + CString(buffer) + "  ";
	}
	else
		MSGG="No Error";
    Show_Msg(MSGG);
}

void Motion_test::OnAxis3_7() 
{
	// TODO: Add your control notification handler code here
	i8094MF_SET_MAX_V(cardNo,AXIS_XYZU,50000);
	i8094MF_AXIS_ASSIGN(cardNo, AXIS_X, AXIS_Y, AXIS_Z); 
	//SET X Y Z for interpolation axis.
	i8094MF_VECTOR_SPEED(cardNo, 7);				//set for cons speed Interpolation (VSV=VV)
	i8094MF_SET_VV(cardNo, 20000);					//set the vector speed as 20000 PPSC
	i8094MF_LINE_3D(cardNo, 10000, 10000,10000);	//run the 3 axis interpolation.
}

void Motion_test::OnAxis3_8() 
{
	// TODO: Add your control notification handler code here
	i8094MF_SET_MAX_V(cardNo,AXIS_XYZU,80000);
	i8094MF_AXIS_ASSIGN(cardNo, AXIS_X, AXIS_Y, AXIS_Z); 
	//SET X Y Z for interpolation axis.
	i8094MF_VECTOR_SPEED(cardNo, 8);      
	//set 3 axis as Symmetrical T curve mode(VSVBVVBVABVAO)
	i8094MF_SET_VSV(cardNo, 100);					//set the vector start speed as 100 PPS.
	i8094MF_SET_VV(cardNo, 20000);					//set the vector speed as 20000 PPS.
	i8094MF_SET_VA(cardNo, 50000);					//set the vector acc. as 50000 PPS/s.
	i8094MF_SET_VAO(cardNo, 20);					//set the vector offset pulse(at VSV speed)= 20 PPS.
	i8094MF_LINE_3D(cardNo, 10000, 10000,20000);	//run the 3 axis interpolation.
}

void Motion_test::OnAxis3_9() 
{
	// TODO: Add your control notification handler code here
	i8094MF_SET_MAX_V(cardNo,AXIS_XYZU,80000);
	i8094MF_AXIS_ASSIGN(cardNo, AXIS_X, AXIS_Y, AXIS_Z); 
	//SET X Y Z for interpolation axis.
	i8094MF_VECTOR_SPEED(cardNo, 9);      
	//set 3 axis as Symmetrical S curve mode (VSVBVVBVKBVAO)
	i8094MF_SET_VSV(cardNo, 100);					//set the vector start speed as 100 PPS.
	i8094MF_SET_VV(cardNo, 20000);					//set the vector speed as 20000 PPS. 
	i8094MF_SET_VK(cardNo, 500);					//set K=5000 PPS/s^2.
	i8094MF_SET_VAO(cardNo, 20);					//set the vector offset pulse(at VSV speed)= 20 PPS.
	i8094MF_LINE_3D(cardNo, 10000, 10000,10000);	//run the 3 axis interpolation.
}

void Motion_test::OnAxis3_10() 
{
	// TODO: Add your control notification handler code here
	i8094MF_SET_MAX_V(cardNo,AXIS_XYZU,80000);
	i8094MF_AXIS_ASSIGN(cardNo, AXIS_X, AXIS_Y, AXIS_Z); 
	//SET X Y Z for interpolation axis.
	i8094MF_VECTOR_SPEED(cardNo, 10);  
	//set 3 axis as Non-Symmetrical T curve mode (VSVBVVBVABVDBVAO)
	i8094MF_SET_VSV(cardNo, 1000);					//set the vector start speed as 1000 PPS.
	i8094MF_SET_VV(cardNo, 20000);					//set the vector speed as 20000 PPS.
	i8094MF_SET_VA(cardNo, 100000);					//set the vector acc. as 100000 PPS/s.
	i8094MF_SET_VD(cardNo, 100000);					//set the vector dec. as 100000 PPS/s.
	i8094MF_SET_VAO(cardNo, 20);					//set the vector offset pulse(at VSV speed)= 20 PPS.
	i8094MF_LINE_3D(cardNo, 10000, 10000,10000);	//run the 3 axis interpolation.
}

void Motion_test::OnAxis3_11() 
{
	// TODO: Add your control notification handler code here
	long fp1=4000;
	long fp2=20000;
	long fp3=20000;
	int sv=200;
	int v=20000; 
	i8094MF_SET_MAX_V(cardNo,0xf,30000);
	i8094MF_AXIS_ASSIGN(cardNo, AXIS_X, AXIS_Y, AXIS_Z); 
	//SET X Y Z for interpolation axis.
	i8094MF_VECTOR_SPEED(cardNo, 11); 
	//set 3 axis as Non-Symmetrical S curve mode (VSVBVVBVKBVLBVAO)
	i8094MF_SET_VSV(cardNo, sv);				//set the vector start speed as sv PPS.
	i8094MF_SET_VV(cardNo, v);					//set the vector speed as v PPS.
	i8094MF_SET_VK(cardNo, 50000);				//set K=500000 PPS/s^2.
	i8094MF_SET_VL(cardNo, 5000);				//set L=50000 PPS/s^2.
	i8094MF_SET_VAO(cardNo, 20);				//set the vector offset pulse(at VSV speed)= 20 PPS.
	i8094MF_LINE_3D(cardNo, fp1, fp2,fp3);		//run the 3 axis interpolation.
}



void Motion_test::OnBtSync1() 
{
	// TODO: Add your control notification handler code here
	//When U Axis IN3 is High,then LATCH encoder Val. and change the Speed.
	i8094MF_SYNC_ACTION(cardNo, AXIS_U, 0, 0X0040, 0, 2, 4);		
	i8094MF_SET_MAX_V(cardNo, AXIS_U, 20000); //set U Axis Max Speed. 20KPPS.
	i8094MF_NORMAL_SPEED(cardNo, AXIS_U, 0); //set U Axis SYS. T Curve.
	i8094MF_SET_V(cardNo, AXIS_U, 2000); //set U Axis Speed as 2,000 PPS.
	i8094MF_SET_A(cardNo, AXIS_U,100000); //set U Axis ACC as 100K PPS/S.
	i8094MF_SET_SV(cardNo, AXIS_U, 100); //set U Axis Start Speed as 100 PPS. 
	i8094MF_FIXED_MOVE(cardNo, AXIS_U, 10000); //set U Axis move 10,000 Pulse.
	i8094MF_SET_PRESET(cardNo, AXIS_U, 100); //set U Axis New Speed as 100 PPSC
	
	while (i8094MF_STOP_WAIT(cardNo, AXIS_U) == NO)
	{ 
		//Waitting Stop
		DoEvents();
		Sleep(1);
	};
	long Vsb = i8094MF_GET_LATCH(cardNo, AXIS_U);
	CString MSGG;
	MSGG= "LATCH encoder= " + Vsb;
    Show_Msg(MSGG);
}

void Motion_test::OnBtSync2() 
{
	// TODO: Add your control notification handler code here
	//When U Axis's encoder Val. is >5000,then Start move Y Axis 2000 PPS.
	i8094MF_SYNC_ACTION(cardNo, AXIS_U, 2, 0X0001, 1, 0, 3); 
	i8094MF_SET_COMPARE(cardNo, AXIS_U, 0, 1, 5000); 
	//Set COMP+ =5,000ATo U Reg.
	i8094MF_SET_MAX_V(cardNo, AXIS_YU, 20000); //set YU Axis Max Speed.20KPPS.
	i8094MF_NORMAL_SPEED(cardNo, AXIS_YU, 0); //set YU Axis SYS. T Curve.
	i8094MF_SET_V(cardNo, AXIS_YU, 2000); //set YU Axis Speed as 2,000 PPS.
	i8094MF_SET_A(cardNo, AXIS_YU,100000); //set YU Axis ACC as 100K PPS/S.
	i8094MF_SET_SV(cardNo, AXIS_YU, 100); //set YU Axis Start Speed as 100 PPS.  
	i8094MF_FIXED_MOVE(cardNo, AXIS_U, 10000); //U Axis move 10,000 Pulse.
	i8094MF_SET_PRESET(cardNo, AXIS_Y, 2000); //Set Y Axis move 2,000 pulseC
}

void Motion_test::OnBtDrvHs() 
{
	// TODO: Add your control notification handler code here
	BYTE cardNo=1; //Set card_No =1C
	i8094MF_DRV_HOLD(cardNo, AXIS_XYU); //Set XYU Axis HOLDC
	
	i8094MF_SET_MAX_V(cardNo, AXIS_U, 10000); //set U Axis Max Speed. 10KPPS.
	i8094MF_NORMAL_SPEED(cardNo, AXIS_U, 0); //set U Axis SYS. T Curve.
	i8094MF_SET_V(cardNo, AXIS_U, 2000); //set U Axis Speed as 2,000 PPS.
	i8094MF_SET_A(cardNo, AXIS_U,1000); //set U Axis ACC as 1000 PPS/S.
	i8094MF_SET_SV(cardNo, AXIS_U, 2000); //set U Axis Start Speed as 2000 PPS.
	i8094MF_SET_AO(cardNo, AXIS_U, 9); //set U Axis low Speed Offset 9 PPSC
	i8094MF_SET_MAX_V(cardNo, AXIS_XY, 20000); //set XY Axis Max Speed. 20KPPS.
	i8094MF_AXIS_ASSIGN(cardNo, AXIS_X, AXIS_Y, 0); 
	//set the axis1 as X axis2 as Y for interpolation axisC
	i8094MF_VECTOR_SPEED(cardNo, 0); //set for cons speed Interpolation (VSV=VV)
	i8094MF_SET_VV(cardNo, 1000); //set the vector speed as 1000 PPS.
	
	i8094MF_FIXED_MOVE(cardNo, AXIS_U, 5000); //U Move 5,000 Pulse.
	i8094MF_LINE_2D(cardNo, 12000, 10000); //run the 2 axis interpolation.
	
	i8094MF_DRV_START(cardNo, AXIS_XYU); //Start the XYU Axes moving at same time.
	//======================================================================
}
