// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"
//===============================
#include "INIT_Dlg.h"
#include "Manual_Test.h"
#include "Motion_Test.h"
//===============================
#include "Val.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog

CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlg)
	DDX_Control(pDX, IDC_But_Manual_Test2, m_Motion_Test);
	DDX_Control(pDX, IDC_But_Manual_Test, m_Manual_Test);
	DDX_Control(pDX, IDC_But_BASIC, m_But_Basic);
	DDX_Control(pDX, IDC_Slot, m_Slot);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlg)
	ON_BN_CLICKED(IDC_Init_Card, OnInitCard)
	ON_BN_CLICKED(IDC_REGISTRATION, OnRegistration)
	ON_BN_CLICKED(IDC_But_BASIC, OnButBASIC)
	ON_BN_CLICKED(IDC_But_Manual_Test, OnButManualTest)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_But_Manual_Test2, OnButManualTest2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg message handlers

BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	BYTE i=0;
	char strTemp[20];
	for (i=1;i<8;i++)
	{
		if (GetNameOfModule(i, strTemp)==94)
		{
			m_Slot.SetCurSel(i-1);
			break;
		}
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CDemoDlg::OnInitCard() 
{
	// TODO: Add your control notification handler code here
	INIT_Dlg INIT_D;
	INIT_D.DoModal();
	//=======================================
}

void CDemoDlg::OnRegistration() 
{
	// TODO: Add your control notification handler code here
		if (I8094MF.REGISTRATION(cardNo,m_Slot.GetCurSel()+1)==YES)
		{
		    Card_Open = true;
			i8094MF_RESET_CARD(cardNo);
			i8094MF_INIT_CARD(cardNo);
			//==========================================================================
			i8094MF_SET_PULSE_MODE(cardNo, AXIS_XYZU, 2);
			//i8094MF_IN3_LEVEL(cardNo,AXIS_XYZU, 1);
			i8094MF_SET_ALARM(cardNo, AXIS_XYZU, 0, 0);
			//i8094MF_SET_ALARM(cardNo, AXIS_XYZU, 1, 0);
			//set cardNo card XYZU axisAALARM input openAand active lowC
			i8094MF_SET_ENCODER(cardNo, AXIS_XYZU, 0, 0, 0); 
			//set cardNo card XYZU axisAEncoder as AB-phase typeAno divisionAZ-phase active lowC
			i8094MF_SET_MAX_V(cardNo, AXIS_XYZU, 16000); 
			i8094MF_EXD_DISABLE(cardNo, AXIS_XYZU);
			i8094MF_SET_LP(cardNo, AXIS_XYZU,0);
			i8094MF_SET_EP(cardNo, AXIS_XYZU,0);
			i8094MF_SET_A(cardNo, AXIS_XYZU,0);
			// Initial Reset
			m_But_Basic.EnableWindow(true);
			m_Manual_Test.EnableWindow(true);
			m_Motion_Test.EnableWindow(true);
		}
		else
		{
			Card_Open = false;
			m_But_Basic.EnableWindow(false);
			m_Manual_Test.EnableWindow(false);
			m_Motion_Test.EnableWindow(false);
		}
}

void CDemoDlg::OnButBASIC() 
{
	// TODO: Add your control notification handler code here
	INIT_Dlg INIT_D;
	INIT_D.DoModal();
}

void CDemoDlg::OnButManualTest() 
{
	// TODO: Add your control notification handler code here
	Manual_Test Manual_D;
	Manual_D.DoModal();
}


void CDemoDlg::OnButManualTest2() 
{
	// TODO: Add your control notification handler code here
	Motion_test Motion_D;
	Motion_D.DoModal();
}

void CDemoDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	CBitmap bm;
	BOOL b = bm.LoadBitmap(IDB_BITMAP1);
	CDC memdc;
	memdc.CreateCompatibleDC(NULL);
	memdc.SelectObject(&bm);
	BITMAP BM1;
	bm.GetBitmap(&BM1);
	b=dc.BitBlt(90,20,BM1.bmWidth,BM1.bmHeight,&memdc,0,10,SRCCOPY);
	// Do not call CDialog::OnPaint() for painting messages
}

